#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

int n,m,a,b,C=1;
int nivel[512],adj[512][512],nadj[512];
bool visited[512],artic[512];
int nartic;

int bfs(int u, int paiu) {
  int menorpai = 0x3f3f3f3f;
  int filhos = 0;
  visited[u] = true;
  for(int i=0;i<nadj[u];i++){
    if(!visited[adj[u][i]]){
      filhos++;
      nivel[adj[u][i]] = nivel[u]+1;
      int filho = bfs(adj[u][i],u);
      if (u!=paiu and filho>=nivel[u] and !artic[u]){
        artic[u] = true;
        nartic++;
      }
      menorpai = min(menorpai,filho);
    } else if(adj[u][i]!=paiu){
      menorpai = min(menorpai,nivel[adj[u][i]]);
    }
  }
  if(u==paiu and filhos>1 and !artic[u]){
    artic[u] = true;
    nartic++;
  }
  return menorpai;
}

int main(){

  while(scanf("%d %d",&n,&m)==2 and n){
    memset(artic,false,n*sizeof(bool));
    memset(visited,false,n*sizeof(bool));
    memset(nadj,0,n*sizeof(int));
    for(int i=0;i<m;i++){
      scanf("%d %d",&a,&b); a--; b--;
      adj[a][nadj[a]++]=b;
      adj[b][nadj[b]++]=a;
    }

    nivel[0]=0; nartic=0;
    bfs(0,0);

    printf("Teste %d\n",C++);
    if(nartic>0){
      for(int i=0;i<n;i++)
        if(artic[i])
          printf("%d ",i+1);
      printf("\n\n");
    } else
      printf("nenhum\n\n");
  }

  return 0;
}
